]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
validate that man links point to something resolveable
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# vim:ts=4 sw=4 noet ft=spec
2#
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
5
6# can be used by builder script to check for version
7%rpm_build_macros {Revision}
8
9%epoch 0
10%x8664 x86_64 amd64 ia32e
11%arm armv3l armv4b armv4l armv5teb armv5tel
12
13# kernel compiler
14%kgcc %{__cc}
15%kgcc_package gcc
16
17# compiler version
18%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
19%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
20
21%__rm /bin/rm --interactive=never
22
23# Build system path macros.
24%__autoconf autoconf %{?debug:-Wall}
25%__automake automake -a -c -f --foreign
26%__autopoint autopoint --force
27
28# add parallel build flags: -jN
29#
30# if you want to disable parallel build do:
31# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
32#
33%__make /usr/bin/make %{?_smp_mflags}
34%__scons /usr/bin/scons %{?_smp_mflags}
35%__waf /usr/bin/waf %{?_smp_mflags}
36%__cmake /usr/bin/cmake
37
38%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
39 [ "$_NCPUS" -gt 2 ] && echo "-j$(($_NCPUS / 2))")
40
41%__gettextize { \
42 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
43 gettextize --copy --force --no-changelog; \
44 else \
45 gettextize --copy --force --no-changelog --intl; \
46 fi; \
47 if [ ! -f po/Makevars ]; then \
48 cp -f po/Makevars{.template,}; \
49 fi; \
50}
51
52%__glib_gettextize glib-gettextize --copy --force
53%__gnome_doc_common gnome-doc-common --copy
54%__gnome_doc_prepare gnome-doc-prepare --copy --force
55%__gtkdocize gtkdocize --copy
56%__intltoolize intltoolize --copy --force
57%__libtoolize libtoolize --copy --force --install
58
59# topdir is where builder script lives,
60# fallback to old style if SPECS/SOURCES dirs were found.
61%_topdir %{expand:%%global _topdir %(
62 if [ -d SPECS -a -d SOURCES ]; then
63 # old style rpmdir: in topdir
64 pwd
65 elif [ -d ../SPECS -a -d ../SOURCES ]; then
66 # old style rpmdir: in subdir
67 cd ..; pwd
68 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
69 # if old style rpm dir exist, go with it
70 echo $HOME/rpm; \
71 elif [ -x ../builder -a ! -d ../builder ]; then
72 # relative new style rpmdir: in package dir
73 cd ..; pwd
74 elif [ -x builder -a ! -d builder ]; then
75 # relative new style rpmdir: in packages
76 pwd
77 elif [ -x packages/builder -a ! -d packages/builder ]; then
78 # relative new style rpmdir: packages dir in current dir
79 cd packages; pwd
80 else
81 # fallback to new style rpmdir
82 echo $HOME/rpm/packages
83 fi; \
84)}%_topdir
85
86# if %{_topdir}/SPECS exists, it's old style structure
87%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
88%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
89
90# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
91# if they don't exist assume we are having custom topdir (which is not named as
92# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
93# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
94%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
95%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
96%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
97
98# The number of cvs changelog entries kept when building package.
99%_buildchangelogtruncate 20
100
101%dependencytracking %{nil}
102
103# Relations between package names that cause dependency loops
104# with legacy packages that cannot be fixed. Relations are
105# specified as
106# p>q
107# where package p has a Requires: on something that package q Provides:
108#
109# XXX Note: that there cannot be any whitespace within the string "p>q",
110# and that both p and q are package names (i.e. no version/release).
111%_dependency_whiteout %{nil}
112
113#-----------------------------------------------------------------
114#
115# (re)definition of %{rpm*flags} with %filterout_* support
116# BuildRequires: awk
117# BuildRequires: rpmbuild(macros) >= 1.315
118#
119# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
120# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
121# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
122# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
123# %rpmldflags = %optldflags - %filterout_ld
124#
125# Regular expressions are supported, but to avoid some character be treated
126# as regular expression it must be escaped twice.
127
128%filter_out \
129 for (i = 1; i in I; i++) { A=0; \
130 for (f in F) { \
131 if (I[i] ~ "^" F[f] "$") A=1; \
132 }; \
133 if (!A) printf(I[i] FS); \
134 }
135
136%rpmcflags %(awk 'BEGIN {
137 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
138 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
139 %{filter_out}
140}')
141
142%rpmcxxflags %(awk 'BEGIN {
143 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
144 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
145 %{filter_out}
146}')
147
148%rpmcppflags %(awk 'BEGIN {
149 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
150 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
151 %{filter_out}
152}')
153
154%rpmldflags %(awk 'BEGIN {
155 split("%{?optldflags}",I);
156 split("%{?filterout_ld}",F)
157 %{filter_out}
158}')
159
160# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
161# but, don't use it, better use gcc as linker
162%ld_rpmldflags %(awk 'BEGIN {
163 split("%{rpmldflags}",F);
164 for (f in F) {
165 s = F[f];
166 if (s ~ /^-Wl,/) {
167 s = substr(s,5);
168 gsub(/,/," ",s);
169 };
170 printf(s FS);
171 };
172}')
173
174#-----------------------------------------------------------------
175#
176# Generate a command which cleans environment, leaving only the
177# most important variables.
178# If any spec requires any additional environment it should
179# redefine %_preserve_env in following manner:
180#
181# # ADDITIONAL_VAR is required because [a good reason here]
182# %define _preserve_env ADDITIONAL_VAR
183
184%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
185
186# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
187%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
188 split("%{?_preserve_env}", P);
189 for (i in P) {
190 p = P[i];
191 if (!ENVIRON[p] || d[p]) {
192 continue;
193 }
194 d[p] = 1;
195 split(ENVIRON[p], V, "");
196 val = p "=";
197 for (j = 1; j in V; j++) {
198 v = V[j];
199 if (v == q)
200 v = qq;
201 else if (v == "\\"")
202 v = q2q;
203 else if (v == "\\\\")
204 v = "\\\\\\\\";
205 else
206 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
207 val = val "" v;
208 }
209 printf(val " ");
210 }
211}')
212
213#-----------------------------------------------------------------
214%configure2_13 { \
215 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
216 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
217 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
218 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
219 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
220 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
221 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
222 %{?__cc:CC="%{__cc}" ; export CC ; } \
223 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
224 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
225 --host=%{_target_platform} \
226 --prefix=%{_prefix} \
227 --exec-prefix=%{_exec_prefix} \
228 --bindir=%{_bindir} \
229 --sbindir=%{_sbindir} \
230 --sysconfdir=%{_sysconfdir} \
231 --datadir=%{_datadir} \
232 --includedir=%{_includedir} \
233 --libdir=%{_libdir} \
234 --libexecdir=%{_libexecdir} \
235 --localstatedir=%{_localstatedir} \
236 --sharedstatedir=%{_sharedstatedir} \
237 --mandir=%{_mandir} \
238 --infodir=%{_infodir} \
239 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
240 %{dependencytracking} \
241}
242
243%cmake \
244%{?__cc:CC="%{__cc}"} \\\
245%{?__cxx:CXX="%{__cxx}"} \\\
246CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
247%{__cmake} \\\
248 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
249 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
250 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
251 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
252 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
253 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
254 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
255 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
256 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG}" \\\
257 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
258 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
259 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
260 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
261 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
262%if "%{_lib}" == "lib64" \
263 -DLIB_SUFFIX=64 \\\
264%endif \
265 -DBUILD_SHARED_LIBS:BOOL=ON \\\
266%{nil}
267
268%scons { \
269%{__scons} \
270 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
271 CFLAGS="${CFLAGS:-%rpmcflags}" \
272 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
273 FFLAGS="${FFLAGS:-%rpmcflags}" \
274 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
275 %{?__cc:CC="%{__cc}"} \
276 %{?__cxx:CXX="%{__cxx}"} \
277 libsuffix=%{_lib} \
278 prefix=%{_prefix} \
279}
280
281# waf. see waf.spec
282%waf { \
283CC="%{__cc}" \
284CXX="%{__cxx}" \
285CPP="%{__cpp}" \
286CFLAGS="%{rpmcflags}" \
287CXXFLAGS="%{rpmcxxflags}" \
288%{__waf} \
289}
290
291#----------------------------------------------------------------
292#%configure_cache 0
293%configure_cache_file %{buildroot}.configure.cache
294
295%configure {./configure \
296 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
297 CFLAGS="${CFLAGS:-%rpmcflags}" \
298 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
299 FFLAGS="${FFLAGS:-%rpmcflags}" \
300 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
301 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
302 %{?__cc:CC="%{__cc}"} \
303 %{?__cxx:CXX="%{__cxx}"} \
304 --host=%{_target_platform} \
305 --build=%{_target_platform} \
306 --prefix=%{_prefix} \
307 --exec-prefix=%{_exec_prefix} \
308 --bindir=%{_bindir} \
309 --sbindir=%{_sbindir} \
310 --sysconfdir=%{_sysconfdir} \
311 --datadir=%{_datadir} \
312 --includedir=%{_includedir} \
313 --libdir=%{_libdir} \
314 --libexecdir=%{_libexecdir} \
315 --localstatedir=%{_localstatedir} \
316 --sharedstatedir=%{_sharedstatedir} \
317 --mandir=%{_mandir} \
318 --infodir=%{_infodir} \
319 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
320 %{dependencytracking} \
321 %{?configure_cache:--cache-file=%{configure_cache_file}} \
322}
323
324# Simple macros to simplify adding bconded options to configure scripts.
325# Each macro requires bcond name and accepts optional option name, if option
326# isn't specified bcond name is used as option name. Options returning
327# --with and --enable also allow third argument which will be added as value
328# ( --with-option=value or --enable-option=value ) in case or positive
329# condition, but won't be added otherwise ( nothing or just --disable-option ).
330
331# Requirements:
332# BuildRequires: rpmbuild(macros) >= 1.527
333
334# Usage example:
335# %{__enable bcond} - returns --enable-bcond iff build condition is set
336# %{__disable bcond option} - returns --enable-option iff bcond is not set
337# %{__enable_disable bcond option value} - returns --enable-option=value if
338# bcond is set, returns --disable-option otherwise
339
340# expand bconds to --enable-something and --disable-something
341%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
342%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
343%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
344
345# same as above, but condition inverted
346%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
347%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
348%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
349
350# expand bconds to --with-something and --without-something
351%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
352%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
353%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
354
355# same as above, but condition inverted
356%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
357%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
358%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
359
360#-----------------------------------------------------------------
361
362# overload to insert debuginfo package
363%prep \
364%if 0%{?_enable_debug_packages}\
365%{debug_package}\
366%endif\
367%%prep\
368%{nil}
369
370# Location of autoconf macros
371%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
372
373# Location of omf files
374%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
375
376# Location of pkgconfig files
377%_pkgconfigdir /usr/%{_lib}/pkgconfig
378# noarch pkgconfig files
379%_npkgconfigdir /usr/share/pkgconfig
380
381# Location of desktop files
382%_desktopdir /usr/share/applications
383%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
384
385# Location of pixmaps for applnk/desktop files
386%_pixmapsdir /usr/share/pixmaps
387
388# Location of themable icons for applnk/desktop files
389%_iconsdir /usr/share/icons
390
391# Location of fonts directories
392%_fontsdir /usr/share/fonts
393
394# Location of Gtk and associated libraries documentation
395%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
396
397# Location of KDE documentation
398%_kdedocdir %{_defaultdocdir}/kde/HTML
399
400# unsermake script
401%__unsermake /usr/share/unsermake/unsermake
402
403# Current date
404%date %(LC_ALL=C date +"%a %b %d %Y")
405
406# Example files, programs, scripts...
407%_examplesdir /usr/src/examples
408
409# Alternative kernel type/version
410%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
411
412# The directory holding Linux kernel sources
413%_kernelsrcdir /usr/src/linux%{_alt_kernel}
414
415# SysV-style initscripts dir
416%_initddir /etc/rc.d/init.d
417
418# If non-empty "debug" macro defined, add "dbg" suffix to release number
419%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
420
421# Bootstrap release macros.
422# Usage:
423# %bcond_with bootstrap
424# Release: %{bootstrap_release 1}
425#
426# Package will have release 1 if built normally,
427# and release 0.zzz.bootstrap if built with bootstrap
428%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
429
430# -n drm to generate kernel%{_alt_kernel}-drm dependency
431%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
432%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
433%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
434
435# -s post to generate Requires(post) dependency
436%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
437%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
438%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
439
440# Requires name = version-release
441%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
442# Requires: name = version
443%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
444# Requires: name = version (version based on querying package %2)
445%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
446
447# Requires: name >= version
448%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
449# Requires: name >= version (version based on querying package %2)
450%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
451
452# \helper for renaming packages
453# %rename old-package
454%rename() \
455Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
456Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
457
458%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
459
460# kernel version-release handling
461%__kernel_ver %{expand:%%global __kernel_ver %( \\
462 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
463 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
464 echo ${Z:-ERROR}; \\
465)}%__kernel_ver
466
467%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -qf include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
468%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -qf include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
469%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
470%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
471
472# `uname -r` to be used in @release field
473%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
474
475# sgml macros
476%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
477%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
478%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
479%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
480%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
481%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
482%docbook_sgmlcat_fix() { for l in \
483'' \
484' -- default decl --' \
485'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
486' -- hacks for opensp --' \
487'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
488'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
489'' \
490; do echo $l; done >> %1 \
491}
492
493# vim - "
494
495# minimum file size needed for compressed documents.
496# just smaller files than this get larger when compressed.
497# some stats:
498# - 0 byte file compressed was 25 bytes .gz
499# - 39 byte file was compressed as 57
500# - with test/test.spec@man 158 byte file was compressed also 158
501%_min_compress_bytes 159
502
503#-----------------------------------------------------------------
504# find and gzip all files in %{_mandir} and %{infodir}
505#
506# Requires: xargs, find
507#
508#%no_install_post_compress_docs 1
509%__spec_install_post_compress_docs { \
510%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
511 %{!?debug:set +x;} \
512 for i in /usr/share/man /usr/X11R6/man; do \
513 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
514 echo "Compress man pages: $i"; \
515 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
516 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
517 find $RPM_BUILD_ROOT$i -type l | while read a; do \
518 m=$(readlink "$a"); \
519 if [[ "$m" = */* ]]; then \
520 # handle links to different man section \
521 l=$(readlink -f "$a"); \
522 # full/relative paths that resolve symlink \
523 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
524 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
525 # full paths that do not resolve symlink \
526 l=${l#/usr/share/man/}; \
527 l=${l#/usr/X11R6/man/}; \
528 else \
529 l=${a#$RPM_BUILD_ROOT$i/}; \
530 l=${l%/*}; \
531 l="$l/$m"; \
532 fi; \
533 rm -f $a; \
534 echo ".so $l" > $a; \
535 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
536 done; \
537 # verify that .so links point to existing files (not allowed to point to "other package")
538 err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
539 l=$(cat "$doc"); \
540 l=${l#.so }; \
541 # TODO: iterate over all man dirs, but in Th there's only one true man dir \
542 test -e $RPM_BUILD_ROOT$i/$l || echo " ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
543 done); \
544 test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
545 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
546 fi; \
547 done; \
548 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
549 echo "Compress info pages: %{_infodir}"; \
550 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
551 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
552 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
553 fi; \
554}; __spec_install_post_compress_docs } }
555
556#-----------------------------------------------------------------
557# Strip executable binaries and shared object files
558#
559# Requires: find, awk, strip, cut, xargs
560#
561# Special macros which affect this process:
562#%no_install_post_strip 1 # disable stripping at all
563#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
564#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
565#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
566#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
567#
568%__spec_install_post_strip {%{!?debug: \
569%{!?no_install_post_strip:__spec_install_post_strip() { \
570%{!?debug:set +x;} \
571if [ -d "$RPM_BUILD_ROOT" ]; then \
572 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
573 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
574 if [ "$modulelist" ]; then \
575 modulecount=$(echo "$modulelist" | wc -l); \
576 printf "Stripping %d kernel modules..." $modulecount; \
577 echo "$modulelist" | xargs -l512 chmod u+w; \
578 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
579 echo "DONE"; \
580 fi; \
581 fi; \
582 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
583 if [ -n "$filelist" ]; then \
584 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
585 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
586 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
587 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
588 if [ -n "$elfexelist" ]; then \
589 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
590 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
591 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
592 echo "DONE"; \
593 fi; \
594 if [ -n "$elfsharedlist" ]; then \
595 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
596 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
597 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
598 echo "DONE"; \
599 fi; \
600 if [ -n "$archiveslist" ]; then \
601 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
602 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
603 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
604 echo "DONE"; \
605 fi; \
606 fi; \
607 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
608 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
609 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
610 if [ -n "$filelist_all" ]; then \
611 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
612 chmod u+w $filelist_all; \
613 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
614 echo "DONE"; \
615 fi; \
616 if [ -n "$filelist_unneeded" ]; then \
617 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
618 chmod u+w $filelist_unneeded; \
619 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
620 echo "DONE"; \
621 fi; \
622 if [ -n "$filelist_debug" ]; then \
623 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
624 chmod u+w $filelist_debug; \
625 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
626 echo "DONE"; \
627 fi; \
628fi; }; __spec_install_post_strip } } }
629
630#-----------------------------------------------------------------
631# remove all RPATH from executable binaries and shared object files
632#
633# Requires: find, awk, cut, xargs, chrpath, uname
634#
635# Special macros which affect this process
636#%no_install_post_chrpath 1 # disable chrpath at all
637#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
638#
639%__spec_install_post_chrpath {%{!?debug: \
640%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
641%{!?debug:set +x;} \
642if [ -d "$RPM_BUILD_ROOT" ]; then \
643 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
644 if [ -n "$files" ]; then \
645 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
646 fi; \
647 if [ -n "$objs" ]; then \
648 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
649 echo "$objs" | \
650 while read file; do \
651 rpath= ; \
652 chmod u+w "$file"; \
653 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
654 case $dir in \
655 '$ORIGIN' ) \
656 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
657 else rpath="$rpath:$dir" ; fi ; \
658 continue ; \
659 ;; \
660 esac ; \
661 newdir=$(readlink -m "$dir"); \
662 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
663 case $dir in \
664 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
665 echo "remove-rpath: $dir in $file"; \
666 ;; \
667 * ) \
668 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
669 else rpath="$rpath:$dir" ; fi ; \
670 ;; \
671 esac ; \
672 done ; \
673 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
674 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
675 done; \
676 fi; \
677fi; }; __spec_install_post_chrpath } } }
678
679# vim: "
680
681#-----------------------------------------------------------------
682# Find all shared object files with unresolved symbols. Warn
683# and terminate if any found (termination can be turned off by define).
684#%no_install_post_check_so 1
685#%skip_post_check_so libwithunresolvedok.so.*
686#
687# NOTE: define skip_post_check_so only if such library really requires
688# unresolved symbols and always leave a comment why it is required:
689# # executable provides symbols foo, bar for those libraries:
690# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
691#
692%__spec_install_post_check_so { \
693__spec_install_post_check_so() { \
694%{!?debug:set +x;} \
695 fail=0; \
696 printf "Searching for shared objects with unresolved symbols..."; \
697 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
698 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
699 done ; \
700 echo " DONE"; \
701 %{!?no_install_post_check_so:return $fail;} \
702}; __spec_install_post_check_so }}
703
704#-----------------------------------------------------------------
705# Verify that for each directory under /var/run package contains
706# tmpfiles.d configuration. Warn and terminate build if config is
707# missing.
708#
709#%no_install_post_check_tmpfiles 1
710#
711%__spec_install_post_check_tmpfiles { \
712__spec_install_post_check_tmpfiles() { \
713%{!?debug:set +x;} \
714 fail=0; \
715 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
716 for d in $RPM_BUILD_ROOT/var/run/*; do \
717 [ -d "$d" ] || continue; \
718 d=${d##$RPM_BUILD_ROOT}; \
719 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
720 echo "No tmpfiles configuration for '$d'";\
721 fail=1 ; \
722 fi \
723 done ; \
724 echo " DONE"; \
725 %{!?no_install_post_check_tmpfiles:return $fail;} \
726}; __spec_install_post_check_tmpfiles }}
727
728#-----------------------------------------------------------------
729# Find and gzip all kernel modules
730#
731# Requires: find
732#
733#%no_install_post_compress_modules 1
734%__spec_install_post_compress_modules { \
735%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
736%{!?debug:set +x;} \
737 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
738 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
739 if [ "$q" ]; then \
740 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
741 echo "$q" | xargs -r %{__gzip} -9nf; \
742 echo "DONE"; \
743 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
744 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
745 fi; \
746 fi; \
747}; __spec_install_post_compress_modules } }
748
749# Remove common Perl files we don't package
750%__spec_install_post_perl_clean {\
751%{!?no_install_post_perl_clean: \
752%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
753} }
754
755#-----------------------------------------------------------------
756# Update GConf2 schemas
757#
758# Requires: GConf2
759#
760%gconf_schema_install() \
761 umask 022; \
762 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
763 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
764%{nil}
765
766%gconf_schema_uninstall() \
767if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
768 umask 022; \
769 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
770 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
771fi; \
772%{nil}
773
774#-----------------------------------------------------------------
775# Update desktop MIME database
776# requires: desktop-file-utils
777%update_desktop_database() {{ \
778 umask 022; \
779 /usr/bin/update-desktop-database -q; \
780};} \
781%{nil}
782
783%update_desktop_database_post %update_desktop_database
784
785%update_desktop_database_postun() {{ \
786if [ "$1" = "0" ]; then \
787 %update_desktop_database \
788fi; \
789};} \
790%{nil}
791
792#-----------------------------------------------------------------
793# Update shared MIME info database
794# requires: shared-mime-info
795#
796%update_mime_database() {{ \
797 umask 022; \
798 /usr/bin/update-mime-database %{_datadir}/mime; \
799};} \
800%{nil}
801
802#-----------------------------------------------------------------
803# Update icon cache
804# BuildRequires: rpmbuild(macros) >= 1.596
805# Requires: hicolor-icon-theme
806#
807%update_icon_cache() {{ \
808 %{!?1:%{error:%{0}: Required theme name missing}} \
809 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
810 umask 022; \
811 touch --no-create %{_iconsdir}/%1; \
812 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
813 fi; \
814};} \
815%{nil}
816
817#-----------------------------------------------------------------
818# Update scrollkeeper database
819# requires: scrollkeeper
820#
821%scrollkeeper_update_post() \
822 /usr/bin/scrollkeeper-update -q; \
823%{nil}
824
825%scrollkeeper_update_postun() \
826if [ "$1" = "0" ]; then \
827 /usr/bin/scrollkeeper-update -q; \
828fi; \
829%{nil}
830
831#-----------------------------------------------------------------
832# Compile GSettings schemas
833# requires: glib2 >= 1:2.26.0
834#
835%glib_compile_schemas() {{ \
836 umask 022; \
837 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
838};} \
839%{nil}
840
841#-----------------------------------------------------------------
842# post %install sequence:
843# - autodeps exceptions
844# - compress all man and info pages,
845# - strip all ELF executables and ELF shared objects if not %debug.
846# - compress kernel modules if any
847
848###################################################################
849# Requires/Provides automation
850# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
851#
852%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
853%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
854%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
855%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
856%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
857 %{?_noautoreq: %{_noautoreq}} \
858 %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
859 %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
860 %{nil}
861
862# helper for wrapping _noautoreq between perl() or pear()
863# Author: Elan Ruusamäe <glen@pld-linux.org>
864# Usage:
865# BuildRequires: rpmbuild(macros) >= 1.654
866# %define _noautoreq_pear Excluded.php PEAR/Something.php
867# %define _noautoreq_perl Apache::.*
868%__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}\\\\\\(%%s\\\\\\) ", $1)}')
869
870#%_noautocompressdoc %{nil}
871#
872%_missing_doc_files_terminate_build 1%{nil}
873%_unpackaged_files_terminate_build %{nil}
874# (X)emacs support
875%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
876%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
877%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
878
879%__php_provides %{nil}
880%__php_requires %{nil}
881%__perl_provides %{nil}
882%__perl_requires %{nil}
883%__mono_provides %{nil}
884%__mono_requires %{nil}
885
886# Perl specific macro definitions.
887%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
888%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
889%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
890%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
891%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
892%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
893
894# Ruby
895%__ruby /usr/bin/ruby
896%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
897%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
898%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
899%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
900%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
901%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
902%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
903%ruby_rdocdir /usr/share/rdoc
904%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
905%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
906%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
907
908%php_pear_dir /usr/share/pear
909%php_data_dir /usr/share/php
910%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
911%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
912%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
913
914# extract php/zend api versions
915%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
916%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
917%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
918%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
919%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
920%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
921%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
922%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
923# "_ts" if ZTS enabled, empty otherwise
924%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
925
926# name of php package
927%php_name php%{?php_suffix}
928# use rpmbuild -D 'php_suffix 54' to build php extension for php 5.4
929# NOTE: error output must be empty. otherwise can't build pecl packages if no php*-devel is installed
930%php_suffix %(c=$(php-config --sysconfdir 2>/dev/null) || echo '' && echo ${c#/etc/php})
931
932# helper macro
933%__php_api_requires(v:) Requires: %{php_name}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
934
935# macros for public use
936# for php extensions (php-pecl)
937%requires_php_extension %{__php_api_requires modules_api php_api_version} \
938%{__php_api_requires zend_module_api} \
939%{__php_api_requires debug php_debug} \
940%{__php_api_requires thread-safety _zend_zts}
941
942# for zend extensions
943%requires_zend_extension %{__php_api_requires zend_module_api} \
944%{__php_api_requires zend_extension_api} \
945%{__php_api_requires debug php_debug} \
946%{__php_api_requires thread-safety _zend_zts}
947
948# for php pdo modules (php-pecl-PDO_*)
949%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
950
951# for using PHP post scripts. for PHP >= 5.0
952%php_webserver_restart \
953[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
954[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
955if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
956 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
957 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
958 %service -q php-fcgi restart \
959 fi \
960fi \
961if [ -x /etc/rc.d/init.d/php-fpm ]; then \
962 %service -q php-fpm restart \
963fi \
964%{nil}
965
966# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
967%php4_webserver_restart \
968[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
969[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
970if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
971 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
972 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
973 %service -q php-fcgi restart \
974 fi \
975fi \
976%{nil}
977
978# X.org helper macros
979%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
980%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
981
982%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
983%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
984%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
985%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
986%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
987# vim: '
988
989%requires_xorg_xserver_extension \
990%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
991%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
992%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
993%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
994%{nil}
995
996%requires_xorg_xserver_xinput \
997%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
998%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
999%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
1000%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
1001%{nil}
1002
1003%requires_xorg_xserver_font \
1004%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1005%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1006%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
1007%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
1008%{nil}
1009
1010%requires_xorg_xserver_videodrv \
1011%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1012%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1013%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
1014%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
1015%{nil}
1016
1017# TCL specific macro definitions.
1018# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
1019%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
1020%tcl_sitearch %{_libdir}/tcl%{tcl_version}
1021%tcl_sitelib %{_datadir}/tcl%{tcl_version}
1022
1023# Python specific macro definitions.
1024# python main version
1025%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
1026
1027# directories
1028%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
1029%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
1030%py_scriptdir %{py_prefix}/share/python%{py_ver}
1031%py_incdir /usr/include/python%{py_ver}
1032%py_sitedir %{py_libdir}/site-packages
1033%py_sitescriptdir %{py_scriptdir}/site-packages
1034%py_dyndir %{py_libdir}/lib-dynload
1035
1036# pure python modules compilation
1037%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1038
1039%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1040
1041# Software written in Python language require Python with main version
1042%pyrequires_eq() Requires: %1
1043
1044# Python 3.x
1045# python main version
1046%__python3 python3
1047%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
1048
1049# directories
1050%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
1051%py3_libdir %{expand:%%global py3_libdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platstdlib'))" 2>/dev/null || echo ERROR)}%py3_libdir
1052%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
1053%py3_sitedir %{expand:%%global py3_sitedir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platlib'))" 2>/dev/null || echo ERROR)}%py3_sitedir
1054%py3_sitescriptdir %{expand:%%global py3_sitescriptdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('purelib'))" 2>/dev/null || echo ERROR)}%py3_sitescriptdir
1055%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
1056%py3_dyndir %{py3_libdir}/lib-dynload
1057
1058# pure python modules compilation
1059%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1060
1061%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1062
1063# node.js libdir
1064# Requirements:
1065# BuildRequires: rpmbuild(macros) >= 1.634
1066%nodejs_libdir /usr/lib/node_modules
1067
1068# Hardlink binary identical .pyc and .pyo files
1069%__spec_install_post_py_hardlink {\
1070%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
1071%{!?debug:set +x;} \
1072local a b c=0 t=0; \
1073if [ -d "$RPM_BUILD_ROOT" ]; then \
1074 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
1075 while read a; do \
1076 b="${a%.pyc}.pyo"; \
1077 if cmp -s "$a" "$b"; then \
1078 ln -f "$a" "$b"; \
1079 c=$((c + 1)); \
1080 fi; \
1081 t=$((t + 1)); \
1082 done < __rpm_pyc; \
1083 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1084 rm -f __rpm_pyc; \
1085fi; \
1086}; __spec_install_post_py_hardlink } }
1087
1088# remove python sources, so that check-files won't complain
1089%py_postclean() \
1090for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1091 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1092done \
1093%{nil}
1094
1095# depmod macro
1096%depmod() { \
1097umask 022; \
1098if [ -e /boot/System.map-%1 ]; then \
1099 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1100else \
1101 if [ -e /boot/System.map ]; then \
1102 /sbin/depmod -a -F /boot/System.map %1; \
1103 else \
1104 /sbin/depmod -a %1; \
1105 fi \
1106fi; \
1107}
1108
1109# XMMS specific macros
1110%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1111%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1112%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1113%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1114%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1115%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1116%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1117%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1118%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1119%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1120
1121%_host_base_arch %{expand:%%global _host_base_arch %(echo %{_host_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_host_base_arch
1122%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1123
1124# user/group checking macros
1125#
1126# Usage:
1127# %userremove myuser
1128#
1129%userremove /usr/lib/rpm/user_group.sh user del
1130%groupremove /usr/lib/rpm/user_group.sh group del
1131#
1132# Usage:
1133# if %usertestrm myuser; then
1134# /usr/sbin/userdel -r myuser
1135# Note:
1136# use these macros only if you need to call userdel/groupdel with
1137# a non-standard option or take an extra action; otherwise use the
1138# %userremove/%groupremove macros
1139#
1140%usertestrm /usr/lib/rpm/user_group.sh user testrm
1141%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1142# user group membership management macros
1143#
1144# Usage:
1145# %addusertogroup [-q] myuser agroup
1146#
1147# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1148#
1149# Requirements:
1150# BuildRequires: rpmbuild(macros) >= 1.515
1151%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1152%{nil}
1153
1154# banner support (useful in {pre,post}{,un} and triggers)
1155#
1156# Usage:
1157# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1158# the banner text, the banner text
1159# the banner text, and following line
1160#EOF
1161# You can use any form of here-document, <<'EOF' <<-EOT will do.
1162# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1163#
1164# -a - append to the banner
1165# -e - send to stderr instead of stdout
1166# -n - no show banner (overrides -t)
1167# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1168# -o - show only once, i.e when package is installed for the first time
1169#
1170# Tests:
1171# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1172# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1173# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1174# rpm -E 'date | %banner -e banner' > m; sh -x m
1175# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1176#
1177%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1178RPM_SCRIPTVERBOSITY=5 \
1179[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1180if [ -x /usr/bin/banner.sh ]; then \
1181 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1182else \
1183 CMD="cat%{-e: >&2}" \
1184fi \
1185eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1186%{nil}
1187
1188# useradd/groupadd macros
1189# Author: Elan Ruusamäe <glen@pld-linux.org>
1190#
1191# Usage:
1192# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1193# [-g initial_group] [-G group[,...]] login
1194#
1195# -u uid. REQUIRED
1196# -g gid/group. REQUIRED
1197# -s defaults to /bin/false
1198# -d defaults to /usr/share/empty
1199# -c No default
1200# -r is accepted but ignored (it's always set)
1201# -k skeleton dir. defaults to /usr/share/empty
1202# rpm specific flags
1203# -P package name. defaults to %{name}
1204#
1205%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1206%{!-u:%{error:useradd: Required argument -u missing}} \
1207%{!-g:%{error:useradd: Required argument -g missing}} \
1208%{!?1:%{error:useradd: Required parameter login missing}} \
1209if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1210 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1211 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1212 exit 1 \
1213 fi \
1214else \
1215 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1216 /usr/sbin/useradd \\\
1217 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1218 -u %{-u*} \\\
1219 -r \\\
1220 -d %{-d*}%{!-d:/usr/share/empty} \\\
1221 -s %{-s*}%{!-s:/bin/false} \\\
1222 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1223 -g %{-g*} \\\
1224 %{-M} \\\
1225 %{-G:-G %{-G*}} \\\
1226 %{expand:%{%{#}}} 1>&2 || exit $? \
1227 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1228fi;
1229# vim: "
1230
1231# Usage:
1232# %groupadd [-P package] [-g gid] group
1233#
1234# -g gid. REQUIRED
1235#
1236# Sample:
1237# %groupadd -P %{name}-base -g %{gid} %{name}
1238
1239%groupadd(g:P:rfo) \
1240%{!-g:%{error:groupadd: Required argument -g missing}} \
1241%{!?1:%{error:groupadd: Required parameter group missing}} \
1242if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1243 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1244 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1245 exit 1 \
1246 fi \
1247else \
1248 echo "Adding group %{1} GID=%{-g*}." \
1249 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1250 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1251fi;
1252
1253# webapp macros
1254# Author: Elan Ruusamäe <glen@pld-linux.org>
1255#
1256# The config is installed/removed inside trigger, this means that you can any
1257# time install apache1/apache/lighttpd package and the configuration file is
1258# updated. if you don't need the config for various reason for specific
1259# webserver, just remove the symlink from config directory using webapp
1260# program. the trigger will not recreate the symlink on upgrades. In other
1261# words the config is linked to webserver config directory on first install of
1262# PACKAGE or WEBSERVER.
1263#
1264# Add package's webserver config to webserver webapps dir.
1265# Usage:
1266# %webapp_register [-f] WEBSERVER WEBAPP
1267#
1268%webapp_register(f) \
1269%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1270if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1271 /usr/sbin/webapp register %1 %2\
1272fi\
1273# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1274if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1275 %{expand:%service -q %%1 reload}\
1276fi\
1277%{nil}
1278
1279# Remove package's config from webserver webapps dir.
1280# Usage:
1281# %webapp_register [-f] WEBSERVER WEBAPP
1282%webapp_unregister(f) \
1283%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1284# remove link if either of the packages are gone \
1285if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1286 /usr/sbin/webapp unregister %1 %2\
1287 %{expand:%service -q %%1 reload}\
1288fi \
1289%{nil}
1290
1291# service macro.
1292# Author: Elan Ruusamäe <glen@pld-linux.org>
1293#
1294# calls usual service restart on package %post, but skips the restart if
1295# administrator has disabled automatic service restarts in either global
1296# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1297#
1298# Usage:
1299# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1300#
1301# -q be silent when service isn't started (for scriplets restaring other package's services)
1302# -n NOOP mode, do not actually restart service
1303#
1304# Requirements:
1305# BuildRequires: rpmbuild(macros) >= 1.268
1306# Requires: rc-scripts
1307# -n option:
1308# BuildRequires: rpmbuild(macros) >= 1.450
1309%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1310
1311# Java macros. based on jpackage macros.java
1312#
1313# Root directory where all Java VMs/SDK/JREs are installed.
1314%_jvmdir %{_libdir}/jvm
1315
1316# Root directory where all Java VMs/SDK/JREs expose their jars
1317%_jvmjardir %{_libdir}/jvm-exports
1318
1319# Root directory for all Java VM/SDK/JRE's private things.
1320%_jvmprivdir %{_libdir}/jvm-private
1321
1322# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1323%_jvmlibdir %{_libdir}/jvm
1324
1325# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1326%_jvmdatadir %{_datadir}/jvm
1327
1328# Root directory for all configurations parts of Java VM/SDK/JRE's
1329%_jvmsysconfdir %{_sysconfdir}/jvm
1330
1331# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1332%_jvmcommonlibdir %{_libdir}/jvm-common
1333
1334# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1335%_jvmcommondatadir %{_datadir}/jvm-common
1336
1337# Root directory for all common configurations parts of Java VM/SDK/JRE's
1338%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1339
1340# Directory where arch-specific (JNI) version-independent jars are installed.
1341%_jnidir %{_libdir}/java
1342
1343
1344# JDK selection. Set this to name of the JDK implementation to use
1345# insead of the system default
1346#%use_jdk icedtea6
1347
1348# expands to the value with right jdk for BuildRequires header
1349# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1350# The requirement will not replace current 'default' JDK
1351%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1352
1353%buildrequires_jdk BuildRequires: %required_jdk
1354
1355%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1356
1357%_javasrcdir %{_usrsrc}/java
1358
1359%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1360%jar %{java_home}/bin/jar
1361%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1362%javac %{java_home}/bin/javac
1363%javadoc %{java_home}/bin/javadoc
1364
1365%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1366
1367%jpackage_script() \
1368install -d $RPM_BUILD_ROOT%{_bindir}\
1369cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1370#!/bin/sh\
1371#\
1372# %{name} script\
1373# JPackage Project <http://www.jpackage.org/>\
1374\
1375# Source functions library\
1376. %{_javadir}-utils/java-functions\
1377\
1378# Source system prefs\
1379if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1380 . %{_sysconfdir}/java/%{name}.conf\
1381fi\
1382\
1383# Source user prefs\
1384if [ -f $HOME/.%{name}rc ]; then\
1385 . $HOME/.%{name}rc\
1386fi\
1387\
1388# Configuration\
1389MAIN_CLASS=%1\
1390BASE_FLAGS=%2\
1391BASE_OPTIONS=%3\
1392BASE_JARS="%(echo %4 | tr ':' ' ')"\
1393\
1394# Set parameters\
1395set_jvm\
1396set_classpath $BASE_JARS\
1397set_flags $BASE_FLAGS\
1398set_options $BASE_OPTIONS\
1399\
1400# Let's start\
1401run "$@"\
1402EOF
1403
1404# jpackage 1.7
1405# Directory for maven depmaps
1406#
1407%_mavendepmapdir /etc/maven
1408%_mavendepmapfragdir /etc/maven/fragments
1409
1410#
1411# add_to_depmap adds an entry to the depmap. The arguments are:
1412#
1413# %1 the original groupid
1414# %2 the original artifact id
1415# %3 the version
1416# %4 the new groupid
1417# %5 the new artifactid
1418#
1419
1420%add_to_maven_depmap() \
1421install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1422cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1423<dependency>\
1424 <maven>\
1425 <groupId>%1</groupId>\
1426 <artifactId>%2</artifactId>\
1427 <version>%3</version>\
1428 </maven>\
1429 <jpp>\
1430 <groupId>%4</groupId>\
1431 <artifactId>%5</artifactId>\
1432 <version>%3</version>\
1433 </jpp>\
1434</dependency>\
1435\
1436EOF\
1437%{nil}
1438
1439#==============================================================================
1440#
1441# update_maven_depmap updates the main maven depmap
1442#
1443%update_maven_depmap() \
1444echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1445if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1446cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1447fi\
1448echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1449
1450# JAVA macros specific for PLD
1451
1452# Directory for tomcat context configuration files
1453%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1454
1455# Tomcat cache path
1456%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1457
1458# Clear tomcat cache
1459# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1460#
1461# Usage:
1462# %%tomcat_clear_cache appname
1463#
1464# Call this script in %postun scriptlet. It will remove compiled jsps related to
1465# given app.
1466#
1467%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1468
1469# PEAR install macros
1470# Author: Elan Ruusamäe <glen@pld-linux.org>
1471#
1472# Usage:
1473# %%pear_package_setup ...
1474#
1475# -a # - also unpack SOURCE#. for PEAR bootstrapping
1476# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1477# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1478# -D - pass -D to %setup (so the build dir is not removed)
1479# -c - register channel from local channel.xml file
1480# -d - pass -d arg to pearcmd
1481#
1482# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1483# destination hierarchy. you should copy the tree to buildroot after
1484# patching/reorganizing with %%pear_package_install.
1485#
1486# additionally BUILDROOT is stripped from files and files are converted to UNIX
1487# line endings.
1488#
1489# the pear install process output is recorded to install.log, you should put it
1490# to %%doc for later debug or just for information.
1491#
1492# additionally additional-packages.txt is produced if it was detected that the
1493# package has optional dependencies. the file format is suitable of displaying
1494# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1495# automatically added for this file.
1496
1497
1498# records install.log and transforms PEAR names to PLD Linux rpm package names.
1499%__pear_install_log \
1500tee install.log \
1501# make post message of optional packages \
1502grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1503if [ -s optional-packages.txt ]; then \
1504 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1505else \
1506 rm -f optional-packages.txt \
1507fi \
1508%{nil}
1509
1510# Command invoking PEAR CLI
1511# Same as /usr/bin/pear, except we force GMT timezone
1512%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT /usr/share/pear/pearcmd.php
1513
1514%pear_install(a:d:n:zD) \
1515%__pear \\\
1516 -c %{builddir}/pearrc \\\
1517 -d doc_dir=/docs \\\
1518 -d temp_dir=/tmp \\\
1519 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1520 -d bin_dir=%{_bindir} \\\
1521 -d data_dir=%{php_pear_dir}/data \\\
1522 -d test_dir=%{php_pear_dir}/tests \\\
1523 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1524 install \\\
1525 --packagingroot=%{builddir} \\\
1526 --offline \\\
1527 --nodeps \\\
1528 %{-f:--force} \\\
1529 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1530 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1531%{nil}
1532
1533# The main macro.
1534# using this macro will append optional-packages.txt to the nocompressdoc list
1535# as it's displayed to user after package install. and adding additional gzip
1536# dep is just waste ;)
1537%pear_package_setup(a:d:n:zDc:) \
1538%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1539%define builddir %{_builddir}/%{srcdir} \
1540%setup -q -c -T %{-D:-D} -n %{srcdir} \
1541%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1542%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1543%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1544%pear_install \
1545%{-z:cd ..} \
1546%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1547cat %{-z:$_N/}.install.log | %__pear_install_log \
1548%undos -f php,html,js,xml \
1549%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1550%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1551%{nil}
1552
1553# Copies extracted PEAR package structure and PEAR registry to buildroot.
1554# Author: Elan Ruusamäe <glen@pld-linux.org>
1555%pear_package_install() \
1556cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1557# tests should not be packaged \
1558%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1559# cleanup backups \
1560find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1561# help the developer out a little: \
1562if [ -f _noautoreq ]; then \
1563 echo "AutoReqdep detected:" \
1564 echo "_noautoreq $(cat _noautoreq)" \
1565fi \
1566%{nil}
1567
1568# Print optional package info for pear packages
1569# Author: Elan Ruusamäe <glen@pld-linux.org>
1570# Usage:
1571# %post -p <lua>
1572# %%pear_package_print_optionalpackages
1573#
1574# Requirements:
1575# BuildRequires: rpmbuild(macros) >= 1.571
1576%pear_package_print_optionalpackages \
1577f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1578if f then \
1579 for l in f:lines() do print(l); end \
1580end \
1581%{nil}
1582
1583
1584# Register OpenLDAP schema.
1585# Author: Elan Ruusamäe <glen@pld-linux.org>
1586#
1587# Usage:
1588# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1589#
1590# -d specify dependant schemas, separated by comma
1591#
1592%openldap_schema_register(d:) \
1593for schema in %*; do \
1594 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1595 %{__sed} -i -e " \
1596 /^include.*local.schema/{ \
1597 iinclude\\t $schema\
1598 } \
1599 " /etc/openldap/slapd.conf \
1600 fi \
1601done \
1602# enable dependant schemas \
1603if [ "%{-d*}" ]; then \
1604 %{__sed} -i -e ' \
1605 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1606 s/^#// \
1607 }' /etc/openldap/slapd.conf \
1608fi \
1609%{nil}
1610
1611# Unregister OpenLDAP schema.
1612# Author: Elan Ruusamäe <glen@pld-linux.org>
1613#
1614# Usage:
1615# %%openldap_schema_unregister %{schemadir}/horde.schema
1616#
1617%openldap_schema_unregister() \
1618for schema in %*; do \
1619 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1620 %{__sed} -i -e " \
1621 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1622 # for symmetry it would be nice if we disable enabled schemas in post, \
1623 # but we really can not do that, it would break something else. \
1624 " /etc/openldap/slapd.conf \
1625 fi \
1626done \
1627%{nil}
1628
1629%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1630
1631
1632# Build modules for kernels 2.6
1633# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1634#
1635# Usage:
1636# %build_kernel_modules -m <modules> -C <directory>
1637#
1638# remember that proper Makefile is still required
1639# Options:
1640# -m <modules> (required) -- comma-separated list of modules to save,
1641# without .ko extension, may be placed in subdirectory
1642# -C <directory> -- change to <directory> before doing anything
1643# -p <arg>, -P <arg> -- arguments passeed to make scripts
1644# -c -- do not execute make clean
1645# <additional arguments> -- all additional arguments will be passed to
1646# make modules
1647#
1648# Additional patching supported via here document. Try:
1649# %build_kernel_modules -m module <<'EOF'
1650# your patch script here
1651# EOF
1652# Don't use it unless patching depends on config options.
1653
1654# Developer note: don't touch it unless you know how to handle '\'.
1655# - \ in script expands to nothing
1656# - \\\ in script expands to \
1657# - \\\ inside definition expands to nothing
1658# - \\\\\\\ inside definition expands to \
1659# - in last line \ has to touch arguments so arguments passing
1660# in new lines (using \) will be supported
1661
1662%build_kernel_modules(p:P:m:C:c) \
1663%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1664 \
1665%define Opts \\\\\\\
1666%if "%{_target_base_arch}" != "%{_host_base_arch}" \\\
1667 %if "%{_host_base_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1668 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1669 %else \\\
1670 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1671 %endif \\\
1672%else \\\
1673 CC="%{kgcc}" \\\
1674%endif \
1675%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1676 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1677 \
1678%{?-C:cd %{-C*}} \
1679compile() { \
1680 local L="<" PATCH_SH; \
1681 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1682 set -e -x \
1683 \
1684 [ -r "%{_kernelsrcdir}/.config" ] || exit 1 \
1685 rm -rf o \
1686 install -d o/include/linux o/include/generated o/arch/x86/include o/arch/powerpc/lib \
1687 ln -sf %{_kernelsrcdir}/.config o/.config \
1688 ln -sf %{_kernelsrcdir}/Module.symvers o/Module.symvers \
1689 if [ -f %{_kernelsrcdir}/include/generated/autoconf.h ]; then \
1690 ln -sf %{_kernelsrcdir}/include/generated/autoconf.h o/include/generated/autoconf.h \
1691 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1692 else \
1693 ln -sf %{_kernelsrcdir}/include/linux/autoconf.h o/include/linux/autoconf.h \
1694 fi \
1695 if [ -d %{_kernelsrcdir}/arch/x86/include/generated ]; then \
1696 ln -s %{_kernelsrcdir}/arch/x86/include/generated o/arch/x86/include \
1697 fi \
1698 \
1699 set +x \
1700 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1701 set -x \
1702 \
1703 install -d o/include/config \
1704 touch o/include/config/MARKER \
1705 ln -sf %{_kernelsrcdir}/include/config/auto.conf o/include/config/auto.conf \
1706 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1707 \
1708 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1709 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1710 ${1+"$@"} \\\
1711 M=$PWD %{MakeOpts}} \
1712 \
1713 %{__make} -C %{_kernelsrcdir} modules \\\
1714 ${1+"$@"} \\\
1715 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1716%{?-C:cd -} \
1717} \
1718compile_old() { \
1719 local L="<" PATCH_SH; \
1720 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1721 set -e -x \
1722 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1723 \
1724for cfg in ${cfgs:-dist}; do \
1725 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1726 \
1727 rm -rf o \
1728 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1729 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1730 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1731 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1732 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1733 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1734 else \
1735 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1736 fi \
1737 \
1738 set +x \
1739 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1740 set -x \
1741 \
1742 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1743 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1744 %{-p*} %{-P*} \\\
1745 %{MakeOpts} \
1746 %else \
1747 install -d o/include/config \
1748 touch o/include/config/MARKER \
1749 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1750 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1751 %endif \
1752 \
1753 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1754 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1755 ${1+"$@"} \\\
1756 M=$PWD %{MakeOpts}} \
1757 \
1758 %{__make} -C %{_kernelsrcdir} modules \\\
1759 ${1+"$@"} \\\
1760 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1761 \
1762 for MODULE in {%{-m*},}; do \
1763 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1764 done \
1765done \
1766%{?-C:cd -} \
1767} \
1768if [ -r "%{_kernelsrcdir}/.config" ]; then \
1769 compile %{*} \
1770else \
1771 compile_old %{*} \
1772fi \
1773%{nil}
1774
1775
1776# Install kernel modules built by %build_kernel_modules
1777# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1778#
1779# Usage:
1780# %install_kernel_modules -m <modules> -d <directory>
1781#
1782# Options:
1783# -m <modules> (required) -- comma-separated list of modules to install,
1784# without .ko extension, may be placed in subdirectory
1785# -d <directory> (required) -- in what subdirectory modules should be
1786# installed (eg. misc, kernel/drivers/net)
1787# -s <suffix> -- suffix to use when installing modules, useful when module
1788# with same name exists in kernel already
1789# -n <file> -- name of modprobe config file to use (without .conf extension)
1790# for defining aliases, only useful with -s
1791
1792%install_kernel_modules(m:d:s:n:) \
1793%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1794%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1795%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1796 \
1797%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1798%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1799 \
1800__install_kernel_modules() { \
1801%{!?debug:set +x;} \
1802 \
1803for MODULE in {%{-m*},}; do \
1804 [ -n "${MODULE}" ] || continue \
1805 MNAME=${MODULE##*/} \
1806 install -D ${MODULE}.ko %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1807 %{?-s:install -d %{ModprobeD} \
1808 echo "alias ${MNAME} ${MNAME}-%{-s*}" >> %{ModprobeD}/%{-n*}.conf} \
1809done \
1810} \
1811__install_kernel_modules_old() { \
1812%{!?debug:set +x;} \
1813local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1814 \
1815for MODULE in {%{-m*},}; do \
1816 [ -n "${MODULE}" ] || continue \
1817 for cfg in ${cfgs:-dist}; do \
1818 [ "$cfg" = smp ] && suf=smp || suf= \
1819 MNAME=${MODULE##*/} \
1820 install -D ${MODULE}-$cfg.ko \\\
1821 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1822 %{?-s:install -d %{ModprobeD}$suf \
1823 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1824 >> %{ModprobeD}$suf/%{-n*}.conf} \
1825 done \
1826done \
1827} \
1828if [ -r "%{_kernelsrcdir}/.config" ]; then \
1829 __install_kernel_modules \
1830else \
1831 __install_kernel_modules_old \
1832fi \
1833%{nil}
1834
1835# patchset macros
1836# Author: Elan Ruusamäe <glen@pld-linux.org>
1837#
1838# Usage:
1839# %patchset_source -f <seq(1) format> <start> [<end>]
1840# %patchset_patch <start> [<end>]
1841#
1842# If <end> is omited, it is assumed to be <start>.
1843#
1844# For example in preamble:
1845# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1846# and in %prep:
1847# %patchset_patch 33 44
1848
1849# generate SourceX urls from range START STOP
1850# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1851# The sources start from 10000
1852%patchset_source(f:b:) %(
1853 base=%{-b*}%{!-b*:10000};
1854 start=$(expr $base + %1);
1855 end=$(expr $base + %{?2}%{!?2:%{1}});
1856 # we need to call seq twice as it doesn't allow two formats
1857 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1858 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1859 paste %{tmpdir}/__ps{1,2};
1860 rm -f %{tmpdir}/__ps{1,2};
1861) \
1862%{nil}
1863
1864# apply sources from %patchset_source
1865# -p specify -pX for %patch line
1866# -b base offset: defaults to 10000
1867%patchset_patch(f:p:b:) %(
1868 base=%{-b*}%{!-b*:10000};
1869 start=$(expr $base + %1);
1870 end=$(expr $base + %{?2}%{!?2:%{1}});
1871 echo ": patchset_patch %1%{?2: to %2}";
1872 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1873) \
1874%{nil}
1875
1876# return EXPANDED source url N from current spec
1877%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1878
1879# browser plugins v2
1880# Author: Elan Ruusamäe <glen@pld-linux.org>
1881#
1882# Usage:
1883# %browser_plugins_add_browser <name> -p <plugindir>
1884#
1885# <name> (required) -- name of the browser. usually %{name}.
1886# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1887# -b -- default blacklists
1888# -a <arch> override arch
1889#
1890# Example:
1891# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1892
1893%_browserpluginsconfdir /etc/browser-plugins
1894%_browserpluginsdir %{_libdir}/browser-plugins
1895%update_browser_plugins /usr/sbin/update-browser-plugins || :
1896
1897%browser_plugins_add_browser(p:b:a:) \
1898 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1899 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1900 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1901 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1902 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1903 %{-b:cat >> $blacklist_file %{-b*}} \
1904%{nil}
1905
1906# Helper for LUA.
1907# split string separated by space into quoted list
1908#
1909# Author: Elan Ruusamäe <glen@pld-linux.org>
1910#
1911# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1912%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1913
1914# adjust /etc/shells by adding and removing shells from there
1915# Author: Elan Ruusamäe <glen@pld-linux.org>
1916#
1917# Usage:
1918# %post -p <lua>
1919# %lua_add_etc_shells /bin/sh /bin/pdksh
1920#
1921# %preun -p <lua>
1922# if arg[2] == 0 then
1923# %lua_remove_etc_shells /bin/bash /bin/rbash
1924# end
1925#
1926# Requirements:
1927# BuildRequires: rpmbuild(macros) >= 1.462
1928#
1929
1930%lua_add_etc_shells() \
1931t = {}\
1932f = io.open("/etc/shells", "r")\
1933if f then\
1934 for l in f:lines() do t[l]=l; end\
1935 f:close()\
1936end\
1937for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1938 if not t[s] then\
1939 print("Adding "..s.." to /etc/shells")\
1940 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1941 end\
1942end\
1943%{nil}
1944
1945%lua_remove_etc_shells() \
1946t = {}\
1947f = io.open("/etc/shells", "r")\
1948if f then\
1949 for l in f:lines() do t[l]=l; end\
1950 f:close()\
1951end\
1952for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1953 print("Removing "..l.." from /etc/shells")\
1954 t[l] = nil\
1955end\
1956s=""\
1957for _, l in pairs(t) do\
1958 s=s..l.."\\n"\
1959end\
1960io.open("/etc/shells", "w"):write(s)\
1961%{nil}
1962
1963# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1964#
1965# Author: Elan Ruusamäe <glen@pld-linux.org>
1966#
1967# Usage:
1968# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1969# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1970#
1971# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1972#
1973# Requirements:
1974# BuildRequires: rpmbuild(macros) >= 1.429
1975#
1976%add_etc_shells(p) %{-p:<lua>}\
1977%{expand:%%lua_add_etc_shells %*}\
1978%{nil}
1979
1980%remove_etc_shells(p) %{-p:<lua>}\
1981%{-p:if arg[2] == 0 then}\
1982%{expand:%%lua_remove_etc_shells %*}\
1983%{-p:end} \
1984%{nil}
1985
1986# Check syntax for Python files
1987#
1988# Author: Elan Ruusamäe <glen@pld-linux.org>
1989# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1990#
1991# Usage:
1992# %py_lint src
1993#
1994# Requirements:
1995# BuildRequires: python
1996# BuildRequires: rpmbuild(macros) >= 1.602
1997
1998%py_lint() \
1999__py_lint() { \
2000%{!?debug:set +x;} \
2001find "$@" -type f -name '*.py' | python -c ' \
2002import sys \
2003import compiler \
2004\
2005found = err = 0\
2006for f in sys.stdin: \
2007 fd = open(f.rstrip()) \
2008 c = fd.read() \
2009 fd.close() \
2010 found = found + 1 \
2011 try: \
2012 compiler.parse(c) \
2013 except SyntaxError, e: \
2014 print "py_lint: %s: %s" % (f.rstrip(), e) \
2015 err = err + 1\
2016\
2017if not found:\
2018 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
2019 sys.exit(1) \
2020elif err: \
2021 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
2022 sys.exit(1) \
2023else: \
2024 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
2025' \
2026}; __py_lint %* \
2027%{nil}
2028
2029# Undos files
2030#
2031# Author: Paweł Zuzelski <pawelz@pld-linux.org>
2032# Author: Elan Ruusamäe <glen@pld-linux.org>
2033#
2034# Usage:
2035# %undos list_of_files
2036# %undos -f EXT[,EXT]
2037# %undos -i -f EXT[,EXT]
2038#
2039# -f EXT[,EXT] - find(1) files by extensions
2040# -i - case insensitive file search
2041#
2042# Example:
2043# Un-DOS all *.js, *.css files
2044# %undos -f js,css
2045# Un-DOS all *.js, *.JS files
2046# %undos -f js -i
2047# undos all Makefiles
2048# %{__find} -name Makefile | xargs %undos
2049#
2050# Requirements:
2051# BuildRequires: sed >= 4.0
2052# BuildRequires: rpmbuild(macros) >= 1.565
2053
2054# NB: make sure this macro stays on one line
2055# NB: make sure it includes newline escape
2056%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
2057%{nil}
2058
2059# Hook to register nagios object based plugins in Nagios NRPE daemon config.
2060#
2061# Author: Elan Ruusamäe <glen@pld-linux.org>
2062#
2063# Usage:
2064# -a NAME -- add command named NAME
2065# -d NAME -- remove command named NAME
2066# -f FILE -- specify plugin configuration FILE to extract command definition from
2067#
2068# Sample:
2069# %triggerin -- nagios-nrpe
2070# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2071#
2072# %triggerun -- nagios-nrpe
2073# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2074#
2075# Requirements:
2076# Requires: grep
2077# Requires: sed >= 4.0
2078# BuildRequires: rpmbuild(macros) >= 1.552
2079%nagios_nrpe(a:d:c:f:) {\
2080 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2081 %{-a:# on -a and config exists \
2082 if [ -f /etc/nagios/nrpe.cfg ]; then \
2083 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
2084 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2085 fi; \
2086 fi;} \
2087 %{-d:# on package remove, -d and config exists \
2088 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
2089 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2090 fi;} \
2091 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
2092 %service -q nrpe restart; \
2093 fi; \
2094}%{nil}
2095
2096# Import or update Cacti template.
2097#
2098# Author: Elan Ruusamäe <glen@pld-linux.org>
2099#
2100# Usage:
2101# %cacti_import_template XMLFILE
2102# XMLFILE -- XML template to import
2103#
2104# Sample:
2105# %post
2106# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
2107#
2108# Requires: cacti >= 0.8.7e-8
2109# BuildRequires: rpmbuild(macros) >= 1.630
2110# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
2111
2112%cacti_import_template() {\
2113v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
2114if [ "$v" != "1.0" ]; then \
2115 rra="--with-template-rras"; \
2116fi; \
2117/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
2118}%{nil}
2119
2120# pre/post script for -upstart subpackages
2121#
2122# Author: Jacek Konieczny <jajcus@jajcus.net>
2123#
2124# Usage:
2125# %upstart_post service_name
2126# %upstart_postun service_name
2127#
2128# Sample:
2129# %post upstart
2130# %upstart_post %{name}
2131#
2132# %postun upstart
2133# %upstart_postun %{name}
2134#
2135# Requirements:
2136# BuildRequires: rpmbuild(macros) >= 1.560
2137# Requires: rc-scripts >= 0.4.3
2138
2139# migrate from init script to upstart job
2140%upstart_post() \
2141 if [ -f /var/lock/subsys/%1 ]; then \
2142 /sbin/service --no-upstart %1 stop \
2143 /sbin/service %1 start \
2144 fi
2145
2146# restart the job after upgrade or migrate to init script on removal
2147# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2148# at this point
2149%upstart_postun() \
2150 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2151 /sbin/initctl stop %1 >/dev/null 2>&1 \
2152 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2153 fi
2154
2155# Haskell Macros
2156# BuildRequires: rpmbuild(macros) >= 1.608
2157%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2158
2159# update /usr/lib*/ghc-*/package.conf.d/package.cache
2160# Requires: ghc
2161# BuildRequires: rpmbuild(macros) >= 1.607
2162#
2163%ghc_pkg_recache() {{ \
2164 umask 022; \
2165 /usr/bin/ghc-pkg recache; \
2166};} \
2167%{nil}
2168
2169
2170# pre/post script for packages supporting systemd units
2171#
2172# Author: Bartlomiej Zimon <uzi18@o2.pl>
2173# Jan Rękorajski <baggins@mimuw.edu.pl>
2174#
2175# Usage:
2176# %systemd_reload
2177# %systemd_service <unit command> service_name1.service service_name2.service
2178# %systemd_service_enable service_name1.service service_name2.service
2179# %systemd_service_disable service_name1.service service_name2.service
2180# %systemd_service_start service_name1.service service_name2.service
2181# %systemd_service_stop service_name1.service service_name2.service
2182# %systemd_service_restart service_name1.service service_name2.service
2183# %systemd_service_reload service_name1.service service_name2.service
2184#
2185# %systemd_post service_name1.service service_name2.service
2186# %systemd_preun service_name1.service service_name2.service
2187# %systemd_trigger service_name1.service service_name2.service
2188#
2189# Sample:
2190# %post
2191# %systemd_post %{name}.service
2192#
2193# %preun
2194# %systemd_preun %{name}.service
2195#
2196# %postun
2197# %systemd_reload
2198#
2199# %triggerpostun -- %{name} < first-version-with-systemd-units
2200# %systemd_trigger %{name}.service
2201#
2202# Requirements:
2203# BuildRequires: rpmbuild(macros) >= 1.647
2204# Requires: systemd-units >= 38
2205
2206%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl --quiet daemon-reload || :
2207
2208%systemd_service_enable() \
2209 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2210 /bin/systemctl --quiet enable %{*} || : \
2211 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2212%{nil}
2213
2214%systemd_service_disable() \
2215 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2216 /bin/systemctl --quiet disable %{*} || : \
2217%{nil}
2218
2219%systemd_service() \
2220 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2221 /bin/systemd_booted && /bin/systemctl --quiet %{*} || : \
2222%{nil}
2223
2224%systemd_service_start() \
2225 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2226 /bin/systemd_booted && /bin/systemctl --quiet start %{*} || : \
2227%{nil}
2228
2229%systemd_service_stop() \
2230 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2231 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2232%{nil}
2233
2234%systemd_service_restart() \
2235 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2236 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2237%{nil}
2238
2239%systemd_service_reload() \
2240 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2241 /bin/systemd_booted && /bin/systemctl --quiet reload %{*} || : \
2242%{nil}
2243
2244%systemd_trigger() \
2245want_enable_service() { \
2246 [ -f /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
2247 [ ${RPM_ENABLE_SYSTEMD_SERVICE:-yes} = no ] && return 1 \
2248 /sbin/chkconfig --list ${1%.service} 2>/dev/null | grep -qsv "[0-6]:on" && return 1 \
2249 return 0 \
2250}\
2251 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2252 for s in %{*}; do \
2253 if want_enable_service $s; then \
2254 /bin/systemctl --quiet enable $s || : \
2255 fi \
2256 done \
2257%{nil}
2258
2259%systemd_post() \
2260 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2261 /bin/systemd_booted && /bin/systemctl --quiet daemon-reload || : \
2262 if [ $1 -eq 1 ]; then \
2263 /bin/systemctl --quiet enable %{*} || : \
2264 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2265 elif [ -z "$NORESTART" ]; then \
2266 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2267 else \
2268 /bin/systemd_booted && echo 'Run "/bin/systemctl restart %{*}" to restart %{*}.' || : \
2269 fi \
2270%{nil}
2271
2272%systemd_preun() \
2273 if [ $1 -eq 0 ]; then \
2274 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2275 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2276 /bin/systemctl --quiet disable %{*} || : \
2277 fi \
2278%{nil}
2279
2280%systemdunitdir /lib/systemd/system
2281%systemdtmpfilesdir /usr/lib/tmpfiles.d
2282
2283# EOF
This page took 1.727019 seconds and 4 git commands to generate.